field line, file_name, file_date
*-------------------------
func main( whatfile )
*-------------------------
local a_file := {  { "FILE_NAME" , "C", 11, 0 },;
                   { "FORUM"     , "C", 10, 0 },;
                   { "SECTION"   , "C", 10, 0 },;
                   { "FILE_TYPE" , "C",  3, 0 },;
                   { "FILE_SIZE" , "N", 12, 0 },;
                   { "FILE_DATE" , "D",  8, 0 },;
                   { "FILE_TITLE", "C", 50, 0 },;
                   { "KEYWORDS"  , "C", 60, 0 },;
                   { "DESCRIPT"  , "M", 10, 0 },;
                   { "WHOUPLOAD" , "C", 12, 0 } }

local mstart := 1, mrec, mendrec, n, max
local mlook1 := "--  Started at"
local mlook2 := "Bytes:"
local mlook3 := "Disposition !"
local mlook4 := "*** Transfer Complete ***"
local a_temp[10], nHandle, mfile := "cisdl.dbf"

#define FILE_NAME  1
#define FORUM      2
#define SECTION    3
#define FILE_TYPE  4
#define FILE_SIZE  5
#define FILE_DATE  6
#define FILE_TITLE 7
#define KEYWORDS   8
#define DESCRIPT   9
#define WHOUPLOAD  10

Clear screen

if whatfile == NIL
  ? "You must indicate a file name to scan"
  ? 
  inkey(8)
  quit
endif

*if !file( mfile ) 
  dbcreate( mfile, a_file )
  if file( "cisdl.ntx" )  // added this 01/14/95
    erase cisdl.ntx
  endif
*endif

dbcreate("line", { { "LINE", "C", 80, 0 } } )
sele 0
use line excl

sele 0
use (mfile)

*if !file( "cisdl.ntx" )  // you may want to change this, as the code now
  ? "Creating index for CISDL.dbf"  // forces reindexing every time
  index on file_name+dtos(file_date) to cisdl
*else
*  set index to cisdl
*endif

sele line
appe from (whatfile) sdf
go top
max := recc()

do while !eof()
  
  //find the beginning of the next record
  locate for mlook1 $ line while !eof()
  
  if found()
    mrec := recno()
    
    // find the END of the current record
    locate for mlook4 $ line while !eof()
    if found()
      mendrec := recno()-1
    else
      ? "Error could not find the last END of record marker"
      close data
      quit
    endif
    
    goto mrec
    
    a_temp[ FORUM ] := substr( line, 1, at(" ", line)-1 )
    n := at("LIB", line )
    a_temp[SECTION] := substr( line, n+4, at("--",line)-2-(n+4) )
    skip
    a_temp[WHOUPLOAD] := trim( line )
    skip
    a_temp[FILE_NAME] := substr( line, 1, at( "/",line)-1 )
    a_temp[FILE_TYPE] := substr( line, at( "/",line)+1, 3 )
    a_temp[FILE_SIZE] := val( substr( line, at(mlook2,line)+6, at(",",line)-1) )
    a_temp[FILE_DATE] := substr( trim(line), rat( ",", trim(line))+2)
    skip 2
    a_temp[FILE_TITLE] := trim(substr( line, at( "Title   : ", line)+10  ))
    skip
    a_temp[KEYWORDS]   := trim(substr( line, at( "Keywords: ", line)+10 ))
    skip 2
    
    a_temp[DESCRIPT] := ""
    do while recno() < mendrec
      a_temp[DESCRIPT] += trim(line)+chr(13)+chr(10)
      skip
    enddo

    sele cisdl
    appe blank
    
    @ 2,2 say a_temp[FILE_NAME] +" "+a_temp[FILE_DATE]+ space(10)
    @ 4,2 say  str( (mrec/max)*100,5,1)+"% complete"
      
    repl file_name  with a_temp[ FILE_NAME ]
    repl forum      with a_temp[ FORUM ]
    repl section    with a_temp[ SECTION ]
    repl file_type  with a_temp[ FILE_TYPE ]
    repl file_size  with a_temp[ FILE_SIZE ]
    repl file_date  with makedate( a_temp[ FILE_DATE ] )
    repl file_title with a_temp[ FILE_TITLE ]
    repl keywords   with a_temp[ KEYWORDS ]
    repl descript   with a_temp[ DESCRIPT ]
    repl whoupload  with a_temp[ WHOUPLOAD ]
      
  endif

  sele line
  skip
  
enddo

//  fclose( nHandle ) 
return NIL

*-------------------------
static func makedate( cdate )
*-------------------------
// turns a character date into a Clipper date value
local a_temp := { "Jan", "Feb", "Mar", "Apr", "May", "Jun",;
                  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" }

local mmonth, myear, mday, n
// check for valid parameter 
if !(valtype( cdate ) == "C")
  return( ctod( space(8) ) )
endif

n := at( "(" , cdate )    // look for the "(" indicating a re-upload

if n > 0                 
  cDate := substr( cDate, n+1, 9 )   // grab the actual (new) upload date
endif

myear := substr( cdate, rat( "-",cdate)+1,2)  // parse out the year & day
mday  := Substr(ltrim(cdate),1, at( "-", ltrim(cDate) )-1 ) 

n := ascan( a_temp, substr( cDate, at("-", cDate )+1,3 ) ) // month lookup

if n < 1                  // we had a parsing error // can't make a date
  return ctod( space(8) )  // return an empty!
endif

return ctod( str( n,2,0)+"/"+mday+"/"+myear ) // otherwise return a date value

